<template lang="pug">
div
	q-breadcrumbs(gutter="sm").q-mb-lg
		q-breadcrumbs-el(icon="home" to="/")
		q-breadcrumbs-el(label="Кухня" to="/kitchen")
		q-breadcrumbs-el(label="Технологические карты" to="/kitchen/techmaps")
		q-breadcrumbs-el(:label="newItem ? 'Новая карта' : 'Редактирование карты'")

	.inner.q-py-md
		q-form.q-gutter-md(@submit="onSubmit")
			ui-input-text(
				v-model="item.name",
				label="Название карты",
				required,
				:loading="loading"
				)
			q-editor(
				v-model="item.description",
				label="Описание карты",
				min-height="5rem",
				lazy-rules
				outlined
				:loading="loading"
				:toolbar="[['bold', 'italic', 'strike', 'underline']]"
				)

			.row.q-col-gutter-md.q-pl-md.q-mt-none
				.col-12.col-md-4
					ui-input-text(
						v-model="item.calories",
						label="Количество калорий"
						type="number",
						:loading="loading"
						)

				.col-12.col-md-4
					ui-input-text(
						v-model="item.carbohydrates",
						label="Количество углеводов",
						type="number"
						required,
						:loading="loading"
						)

				.col-12.col-md-4
					ui-input-text(
						v-model="item.fats",
						label="Количество жиров",
						type="number"
						required,
						:loading="loading"
						)

				.col-12.col-md-4
					ui-input-text(
						v-model="item.proteins",
						label="Количество протеинов",
						type="number"
						required,
						:loading="loading"
						)

			collection-ingredient(v-model="item.techMapItems")

			q-btn(
				:label="newItem ? 'Добавить карту' : 'Сохранить карту'",
				type="submit",
				color="primary"
				:loading="loading"
			)


</template>

<script lang="ts">
	import { computed, defineComponent, onMounted, ref } from 'vue'
	import { mapWritableState } from 'pinia'
	import { ITechMap } from '@/plugins/utils/types'
	import { useRouter } from 'vue-router'
	import UiInputText from '@/components/ui/UiInputText.vue'
	import CollectionIngredient from '@/pages/kitchen/components/CollectionIngredient.vue'
	import { useKitchenTechMapsStore } from '@/pages/kitchen/children/techmaps/store'
	import { useQuasar } from 'quasar'

	export default defineComponent({
		name: 'PageKitchenTechMapsItem',

		props: ['id'],

		components: {
			UiInputText,
			CollectionIngredient,
		},

		setup(props) {
			const $q = useQuasar()
			const newItem = ref(props.id === undefined)
			const store = useKitchenTechMapsStore()
			const router = useRouter()

			onMounted(() => {
				store.getTechMapById(props.id)
			})

			return {
				newItem,
				loading: computed(() => store.loading),
				async onSubmit() {
					const { id } = (await store.saveTechMapItem()) as unknown as ITechMap
					await router.push(`/kitchen/techmaps/${id}`)
					$q.notify({
						color: 'positive',
						message: newItem.value ? 'Новая карта добавлена' : 'Изменения сохранены',
					})
				},
			}
		},

		computed: {
			...mapWritableState(useKitchenTechMapsStore, {
				item: 'item',
			}),
		},
	})
</script>
